// Sistemas con Demora
// 
clear;
xdel;
clc;

s=%s;
Gp=syslin("c",5,10*s+1);    // Transferencia de la planta
Gc=syslin("c",s+1,s);       // Transferencia del compensador
Gt=Gp*Gc                    // Transferencia de Lazo Abiero
show_margins(Gt,'bode')     // Gráfico de Margende Fase y Ganancia
[margen,fc]=p_margin(Gt);   // Margen de Fase
margen 
wc=2*%pi*fc                 // Frecuencia de corte en rad/seg.
Td=margen*%pi/180/wc        // Retardo Máximo
w=logspace(-3,1,300);       //w=frequencias en rad/seg.
frq=w/2/%pi;                //frq=frequencias en Hz
[frq1,rep] =repfreq(Gt,frq);// Calcula la respuesta en frecuencia
                            // en números complejos
[db,phi]=dbphi(rep);        // Transforma los complejos en módulo y fase
phi_r= -w*Td*180/%pi;       // Cálculo de la fase que agrega el retardo
phi_t=phi+phi_r;            // Fase Total.
xdel(winsid());
// Gráfico de Bode con retardo.
subplot(211)                
plot2d("ln",w,db,color("blue"));
xgrid(color("gray"))
title("Diagrama de Bode de Ganancia")
subplot(212)
plot2d("ln",w,phi_t,color("red"));
xgrid(color("gray"))
title("Diagrama de Bode de Fase")

// Cálculo de la función retardo por el método de Pade
function [Gr]=Pade(nd,Td)
// nd : Orden de la transferencia
// Td : Retardo
//nd=4;
//Td=1;
s=%s;
Ns=0;
Ds=0;
for j=0:nd
    Ns=Ns+(factorial(2*nd-j)*factorial(nd))/(factorial(2*nd)*factorial(j)*factorial(nd-j))*(-s*Td)^j
    Ds=Ds+(factorial(2*nd-j)*factorial(nd))/(factorial(2*nd)*factorial(j)*factorial(nd-j))*(s*Td)^j 
end
Gr=syslin("c",Ns,Ds)
endfunction;
//
// Respuesta en el tiempo de la aproximación de Pade
xdel
T=0:0.001:3; // Vector de Tiempos
Yt=[];
for i=1:4
    Ga=Pade(i,1);
    Y=csim('step',T,Ga);
    Yt=[Yt;Y];
end   
plot2d(T,Yt')
xgrid(color("gray"))
title('Aproximación de Pade')
figure(2)
f = gcf();
f.background = 8;
//
// Gráfico de Fase de la aproximación de Pade
Ga=zeros(8,1)
for i=1:8
    Ga(i,1)=Pade(i,1)
end   
Ga
phaseplot(Ga);
frec=logspace(-3,2,300);
fase=-frec*180/%pi;
plot2d(frec/2/%pi,fase)
xgrid(color("gray"))
title('Aproximación de Pade')
//
// Respuesta a lazo Cerrado.
xdel;
Td=0.8;
n=3;
Gr=Pade(n,Td)           // Aproximación de Pade
GH=Gt*Gr;               // Transferencia de Lazo Abiero
Tlc=GH/(1+GH);          // Transferencia de Lazo Cerrado
T=0:0.01:20;            // Vector de Tiempos
Ylc=csim('step',T,Tlc); // Respuesta a lazo cerrado
plot2d(T,Ylc,color("scilabgreen4"));
xgrid(color("gray"));
title('Respuesta de Lazo Cerrado');


